#<profile4xi profile = "10" />
# -------------------------------------------------------------------------------------------------
#<program4xi program = "_cleanup4xi.py">
#<abstract4xi abstract = "providing function _cleanup4xi"/>
#<refer4xi reference = "process.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = ['_cleanup4xi'] 
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread   
import _winapi

import signal
import itertools
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
try:                             # Binary ones
    import _multiprocessing
except:
    pass
try:                             # Python ones
    from multiprocessing.process import _cleanup
except:
    print("_cleanup4xi.py *** failed in from multiprocessing.process import _cleanup ***")
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from current_process4xi import list_children_current_process4xi
from current_process4xi import discard_child_current_process4xi
from print4xi import print4xi
from sleep4xi import omega2sleep4xi
from time4xi import time4xi
#"
#/>



# -------------------------------------------------------------------------------------------------
#<function4xi function = "cleanup4xi" usage = "
#     process.py
#         _cleanup()
#"> 
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
#
def _cleanup4xi():

    '''
    checks for processes which have finished
    '''

    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------
          
    class2print = "_cleanup4xi"
    method2print = "_cleanup4xi"

    
    message2print = "{started" + "; cleanup4xi-started: " + str(_cleanup4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print) 
        
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------        
     
    
    # check for processes which have finished 
    ack2discard = False
    nack2discard = True 
    
    
    for childprocess2xi in list_children_current_process4xi():             # dragonized list(get_current_process4xi()._children):
    
        message2print = "{got" + "; childprocess2xi-got-by-cleanup4xi: " + str(childprocess2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                        
                
    
        if childprocess2xi._popen.poll() is not None:
            try:
            
                message2print = "{passing" + "; childprocess2xi-passing-to-discard-child-current-process4xi-by-cleanup4xi: " + str(childprocess2xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)          
                        
                discard_child_current_process4xi(childprocess2xi)          # dragonized _current_process._children.discard(p2xi)
                
                message2print = "{performed" + "; discard-child-current-process4xi-performed-by-cleanup4xi: " + str(discard_child_current_process4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                
                nack2discard = False
                           
            except:
                ack2discard = False
                
                nack2discard = True
                
                message2print = "{yielded" + "; nack2discard-yielded-by-cleanup4xi: " + str(nack2discard)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print) 
                
                
                        
        omega2sleep4xi(class2print, method2print)                          # dragonized giving time to others

    if ((ack2discard is False) or (nack2discard is True)):                 # something went wrong
    
        message2print = "{warned" + "; ack2discard-warned-by-cleanup4xi: " + " ** " + str(ack2discard)  + " ** " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------                    
    message2print = "{returning" + "; cleanup4xi-returning: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)      
                  
           
#</function4xi>
#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_cleanup4xi.txt
#   sense-test-cleanup4xi.xml
#   reason-test-cleanup4xi.xml
#   ace-test-cleanup4xi.xml
#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of _cleanup4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
